\l

lucasU(p,q,n)=2*polcoeff(lift(Mod((p+x)/2,x^2+4*q-p^2)^n),1);
lucasV(p,q,n)=2*polcoeff(lift(Mod((p+x)/2,x^2+4*q-p^2)^n),0);

{primU(p,q,n)=local(m,t=1);fordiv(n,d,m=moebius(d);
if(m!=0,t=t*lucasU(p,q,n/d)^m));t;}

{primV(p,q,n)=local(m,t=1);fordiv(n,d,m=moebius(d);
if(m!=0&&d%2==1,t=t*lucasV(p,q,n/d)^m));t;}

pzr(z,x)=sum(k=1,4,z[k]*x^(4-k));

{rc(z)= \\ real root(s) of cubic sum(k=1,4,z[k]*x^(4-k))
local(d,ans,a2,a1,a0,q,r,s,c,th);
d=z[1];
ans=[];
if(d==0,
 print("not a cubic"),
 a2=z[2]/d;
 a1=z[3]/d;
 a0=z[4]/d;
 q=a1/3-a2^2/9;
 r=(a1*a2-3*a0)/6-a2^3/27;
 if(q==0,
  if(r>=0,
   ans=[(2*r)^(1/3)-a2/3],
   ans=[-(-2*r)^(1/3)-a2/3]),
  s=sqrt(abs(q));
  c=r/s^3;
  if(q>0,
   ans=[2*s*sinh(1/3*asinh(c))-a2/3],
   if(c>1,
    ans=[2*s*cosh(1/3*acosh(c))-a2/3],
    if(c<-1,
     ans=[-2*s*cosh(1/3*acosh(-c))-a2/3],
     th=acos(c);
     ans=vector(3,k,2*s*cos((th+2*k*Pi)/3)-a2/3))))));
ans;}

{kpp(ls,N)=local(ok=1,F,R,c1,c2,c3,c4,b,v,u,vn,vo,un,uo,n,d,zs,z,rs,lr,r,rr,tst);
F=gcd(N+1,prod(k=1,length(ls),ls[k]));
R=(N+1)/F;
print();print("fraction = "round(10^6*log(F)/log(N))"/10^6");
if(N>F^4||F^3>N,print("Fail");ok=0);
c1=((N+1)/F)%F;
c2=((N+1-c1*F)/F^2)%F;
c3=((N+1-c1*F-c2*F^2)/F^3);
c4=c3*F+c2;
for(t=-5,5,if(issquare((c1+t*F)^2-4*(t-c4)),print("Fail "t);ok=0,print("OK "t)));
b=contfrac(c1/F);
v=0;vn=1;u=1;un=b[1];n=1;
while(F^4>vn^2*N,n=n+1;bn=b[n];uo=u;u=un;vo=v;v=vn;un=bn*un+uo;vn=bn*vn+vo);
d=round(c4*v/F);
zs=[
[v,-u*F+c1*v,-c4*v+d*F-u,d],
[v,+u*F-c1*v,-c4*v-d*F-u,d]];
default(realprecision,round(log(N)/3/log(10))); \\ adjust realprecision to 30%
for(j=1,2,print();print("Case "j);z=zs[j];rs=rc(z);lr=length(rs);
for(k=1,lr,r=rs[k];rr=round(r);
print();print("Round of root:");print(rr);
tst=0;
if(pzr(z,rr)*pzr(z,rr+1)<0,tst=+1;print("Root OK: above the round"));
if(pzr(z,rr)*pzr(z,rr-1)<0,tst=-1;print("Root OK: below the round"));
if(tst==0,print("Fail");ok=0));
if(lr==1,print();print("Other roots are complex")));
print();
if(ok==1,print("Proof completed"),print("Not yet completed"));print();}

{kpm(ls,N)=
local(ok=1,F,R,c1,c2,c3,c4,b,v,u,vn,vo,un,uo,n,d,z,rs,lr,r,rr,tst);
F=gcd(N-1,prod(k=1,length(ls),ls[k]));
R=(N-1)/F;
print();print("fraction = "round(10^6*log(F)/log(N))"/10^6");
if(N>F^4||F^3>N,print("Fail");ok=0);
c1=((N-1)/F)%F;
c2=((N-1-c1*F)/F^2)%F;
c3=((N-1-c1*F-c2*F^2)/F^3);
c4=c3*F+c2;
for(t=0,5,if(issquare((c1+t*F)^2+4*(t-c4)),print("Fail "t);ok=0,print("OK "t)));
b=contfrac(c1/F);
v=0;vn=1;u=1;un=b[1];n=1;
while(F^4>vn^2*N,n=n+1;bn=b[n];uo=u;u=un;vo=v;v=vn;un=bn*un+uo;vn=bn*vn+vo);
d=round(c4*v/F);
z=[v,u*F-c1*v,c4*v-d*F+u,-d];
default(realprecision,round(log(N)/3/log(10))); \\ adjust realprecision to 30%
rs=rc(z);lr=length(rs);
for(k=1,lr,r=rs[k];rr=round(r);
print();print("Round of root:");print(rr);
tst=0;
if(pzr(z,rr)*pzr(z,rr+1)<0,tst=+1;print("Root OK: above the round"));
if(pzr(z,rr)*pzr(z,rr-1)<0,tst=-1;print("Root OK: below the round"));
if(tst==0,print("Fail");ok=0));
if(lr==1,print();print("Other roots are complex"));
print();
if(ok==1,print("Proof completed"),print("Not yet completed"));print();}
